#version 450
#extension GL_EXT_buffer_reference : require

layout(buffer_reference, buffer_reference_align = 16) buffer ObjectBuffer {
  mat4 model[];
};

layout( push_constant ) uniform constants {
  mat4 view;
  mat4 proj;
  ObjectBuffer objects;
} scene;

layout(set = 0, binding = 0) uniform SceneUniformBuffer {
  mat4 test;
} scene_ubo;

layout(location = 0) in vec3 inPosition;
layout(location = 1) in vec3 inColor;
layout(location = 2) in vec2 inTex;

layout(location = 0) out vec3 fragColor;
layout(location = 1) out vec2 fragTex;

void main() {
  gl_Position = scene.proj * scene.view * scene.objects.model[1] * vec4(inPosition, 1.0);
  fragColor = inColor;
  fragTex = inTex;
}
